// Copyright Istio Authors
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "istio.io/client-go/pkg/apis/networking/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// ProxyConfigLister helps list ProxyConfigs.
// All objects returned here must be treated as read-only.
type ProxyConfigLister interface {
	// List lists all ProxyConfigs in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.ProxyConfig, err error)
	// ProxyConfigs returns an object that can list and get ProxyConfigs.
	ProxyConfigs(namespace string) ProxyConfigNamespaceLister
	ProxyConfigListerExpansion
}

// proxyConfigLister implements the ProxyConfigLister interface.
type proxyConfigLister struct {
	indexer cache.Indexer
}

// NewProxyConfigLister returns a new ProxyConfigLister.
func NewProxyConfigLister(indexer cache.Indexer) ProxyConfigLister {
	return &proxyConfigLister{indexer: indexer}
}

// List lists all ProxyConfigs in the indexer.
func (s *proxyConfigLister) List(selector labels.Selector) (ret []*v1beta1.ProxyConfig, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.ProxyConfig))
	})
	return ret, err
}

// ProxyConfigs returns an object that can list and get ProxyConfigs.
func (s *proxyConfigLister) ProxyConfigs(namespace string) ProxyConfigNamespaceLister {
	return proxyConfigNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// ProxyConfigNamespaceLister helps list and get ProxyConfigs.
// All objects returned here must be treated as read-only.
type ProxyConfigNamespaceLister interface {
	// List lists all ProxyConfigs in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.ProxyConfig, err error)
	// Get retrieves the ProxyConfig from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.ProxyConfig, error)
	ProxyConfigNamespaceListerExpansion
}

// proxyConfigNamespaceLister implements the ProxyConfigNamespaceLister
// interface.
type proxyConfigNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all ProxyConfigs in the indexer for a given namespace.
func (s proxyConfigNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.ProxyConfig, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.ProxyConfig))
	})
	return ret, err
}

// Get retrieves the ProxyConfig from the indexer for a given namespace and name.
func (s proxyConfigNamespaceLister) Get(name string) (*v1beta1.ProxyConfig, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("proxyconfig"), name)
	}
	return obj.(*v1beta1.ProxyConfig), nil
}
